// processing code
// http://myinventions.pl

import ddf.minim.*;
import ddf.minim.analysis.*;
Minim minim;
AudioInput WE;
FFT widmo;

void setup()
{
  size(1024, 600);
  stroke(255);
  minim = new Minim(this);
  WE = minim.getLineIn(Minim.STEREO, 1024, 44100, 16);
  widmo = new FFT(WE.bufferSize(), WE.sampleRate());
}

void draw()
{
  background(0);
  for(int i = 0; i < WE.bufferSize() - 1; i++)
  {
    line(i, 100 + WE.left.get(i)*100, i+1, 100 + WE.left.get(i+1)*100);
    line(i, 300 + WE.right.get(i)*100, i+1, 300 + WE.right.get(i+1)*100);
  }
  widmo.forward(WE.mix);
  for(int i = 0; i < widmo.specSize(); i++)
  {
    line(i, height, i, height - widmo.getBand(i));
  }
}

void stop()
{
  WE.close();
  minim.stop();
  super.stop();
}
